#include "sql.ch"
#include "sqlext.ch"
#include "dcdialog.ch"

PROCEDURE DbeSys() ; Return
PROCEDURE AppSys() ; Return

PROCEDURE Main()

LOCAL oConnection, oCursor, GetList[0], GetOptions, oBrowse,oBrowseds, i, cStatement, ;
      cConnectString, cTableName, aSort,oDataset

// set up default configuration of GUI browse headers for sorting
aSort := Array(4)
aSort[1] := GRA_CLR_WHITE    // Sort Selected Color (Foreground)
aSort[2] := GRA_CLR_RED      // Sort Selected Color (Background)
aSort[3] := GRA_CLR_WHITE    // Sort Unselected Color (Foreground)
aSort[4] := GRA_CLR_DARKGRAY // Sort Unselected Color (Background)
DC_BrowseSort(aSort)

* nastavenie charset tu treba ANSI, inak zle
SET CHARSET TO ANSI
*SET CHARSET TO OEM                // toto funguje ok 

DC_AutoRestoreWindow({HKEY_LOCAL_MACHINE,'Software\Donnay Software\Samples\Windows'})

cConnectString := "SourceDB=d:\#POKUSY\SQLDBFFOXPRO4;DRIVER=Microsoft Visual FoxPro Driver;SERVER=(local);UID=;PWD=;SourceType=DBF;Exclusive=No;Collate=Slovak;NULL=NO;DELETED=NO;BACKGROUNDFETCH=NO"

cStatement := 'SELECT CLV,PCS,VLA FROM VL800490.DBF ORDER BY VLA'

oConnection := SQLConnection():new()

oConnection:driverConnect(nil, @cConnectString,SQL_DRIVER_NOPROMPT,.T.)

if ! oConnection:isConnected
*  DC_WinAlert("Pripojenie ku databaze neuspesne !!!")
  Return
else
*  DC_WinAlert("Pripojenie ku databaze uspesne")
endif


oDataSet := oConnection:DataSet(cStatement,,,,,,,,.T.) 
oDataSet:Sort("VLA")
oDataSet:Gotop()


nField := oDataset:FieldPos("VLA")
hmeno:="Budi Jn"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif

bdataset:={||oDataset:Browsefilter:={|aRow,nRow,oData| like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) )}}
eval(bdataset)


@ 0,0 DCBROWSE oBrowseds DATA oDataSet ;  
           SIZE 150,20 ;
	   PRESENTATION DC_BrowPres()


	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("CLV")) ;	// ozn. registra
		HEADER "CLV"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("PCS")) ;	// ozn. registra
		HEADER "PCS"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("VLA")) ;	// ozn. registra
		HEADER "VLA"   WIDTH 50 PARENT oBrowseds
			
	DCREAD GUI ;
	   FIT ;
	   OPTIONS GetOptions ;
	   BUTTONS DCGUI_BUTTON_EXIT ;
	   TITLE 'Browsing with SQLexpress' ;
		EVAL {|o|SetAppWindow(o), ;
			Eval(bdataset);	
			}

* ukonenie spojenia z SQL databzoi
oConnection:destroy()

Return

//-----------------------------------------------------------------------------

STATIC FUNCTION CreateSQLCursor( oConnection, nMode, cStatement )

Local oCursor, nSuccess := SQL_XPP_ERROR

oConnection:displayErrors := .t.

DEFAULT nMode := 1

if nMode == 1
  oCursor  := SQLSelect():new(cStatement, oConnection, SQL_CONCUR_READ_ONLY, SQL_CURSOR_DYNAMIC)
  nSuccess := oCursor:execute()
elseif nMode == 2
  // retrieve a max of 1000 rows and convert date-time values to Xbase++ dates (loose time portion)
  oCursor  := SQLDataSet():new(cStatement, oConnection,,,1000,,,.t.,.t.)
  nSuccess := oCursor:execute() // don't really need to execute an SQLDataSet, it's just here for consistency
endif

oConnection:displayErrors := .f.

RETURN oCursor

* -------------

FUNCTION SQLFieldBlock( oCursor, nField )

Return {|x|iif(Pcount()==0, oCursor:fieldGet(nField), oCursor:fieldPut(nField, x))}

* -------------

******************************************
FUNCTION SQLFieldBlock2( oCursor, nField )	// prava pre konverziu ANSI to OEM
******************************************

Return {|x|iif(Pcount()==0, iif( !empty(oCursor:fieldGet(nField)) , convtooemCP( oCursor:fieldGet(nField) )," ") , oCursor:fieldPut(nField, x))}


******************************************
FUNCTION SQLFieldBlock5( oCursor, nField )	// prava pre konverziu ANSI to OEM
******************************************

Return {|x|iif(Pcount()==0, iif( !empty(oCursor:fieldGet(nField)), lat_ibm(upper( oCursor:fieldGet(nField))) ," ") , oCursor:fieldPut(nField, x))}



FUNCTION SQLSortBlock( oCursor, nField, nColumn )

RETURN {|a,b,descend|oCursor:sort(IIF(descend,;
              {|x,y|IIF(Valtype(x[nField])='C', ;
                    Upper(x[nField]) > Upper(y[nField]), x[nField] > y[nField])}, ;
              {|x,y|IIF(Valtype(x[nField])='C', ;
                    Upper(x[nField]) < Upper(y[nField]), x[nField] < y[nField])})), ;
              nColumn := nField}



**********************************
FUNCTION LAT_IBM(ptext)        // Funkcia pre odstranenie diakritiky z textu v LATIN-2
**********************************         // funkcne identicka s LAT_IBM z FoxPro CS Lib
* pvodn verzia pre DOS Latin 2 - CP852
*****************************************************
* potrebn pre dulne porovnvanie oboch kdovch strnok

LOCAL outriadok:="",pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet

                znak:=asc(ptext[i])

*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127 .or. znak=42 .or. znak=63
                DO CASE
                CASE znak==128
                        znak:=67
                CASE znak==129
                        znak:=117
                CASE znak==130
                        znak:=101
                CASE znak==131
                        znak:=97
                CASE znak==132
                        znak:=97
                CASE znak==133
                        znak:=117
                CASE znak==134
                        znak:=99
                CASE znak==135
                        znak:=99
                CASE znak==136
                        znak:=108
                CASE znak==137
                        znak:=101
                CASE znak==138
                        znak:=79
                CASE znak==139
                        znak:=111
                CASE znak==140
                        znak:=105
                CASE znak==141
                        znak:=90
                CASE znak==142
                        znak:=65
                CASE znak==143
                        znak:=67
                CASE znak==144
                        znak:=69
                CASE znak==145
                        znak:=76
                CASE znak==146
                        znak:=108
                CASE znak==147
                        znak:=111
                CASE znak==148
                        znak:=111
                CASE znak==149
                        znak:=76
                CASE znak==150
                        znak:=108
                CASE znak==151
                        znak:=83
                CASE znak==152
                        znak:=115
                CASE znak==153
                        znak:=79
                CASE znak==154
                        znak:=85
                CASE znak==155
                        znak:=84
                CASE znak==156
                        znak:=116
                CASE znak==157
                        znak:=76
                CASE znak==158
                        znak:=120
                CASE znak==159
                        znak:=99
                CASE znak==160
                        znak:=97
                CASE znak==161
                        znak:=105
                CASE znak==162
                        znak:=111
                CASE znak==163
                        znak:=117
                CASE znak==164
                        znak:=65
                CASE znak==165
                        znak:=97
                CASE znak==166
                        znak:=90
                CASE znak==167
                        znak:=122
                CASE znak==168
                        znak:=69
                CASE znak==169
                        znak:=101
                CASE znak==170
                        znak:=32
                CASE znak==171
                        znak:=122
                CASE znak==172
                        znak:=67
                CASE znak==173
                        znak:=115
                CASE znak==181
                        znak:=65
                CASE znak==182
                        znak:=65
                CASE znak==183
                        znak:=69
                CASE znak==184
                        znak:=83
                CASE znak==189
                        znak:=90
                CASE znak==190
                        znak:=122
                CASE znak==198
                        znak:=65
                CASE znak==199
                        znak:=97
                CASE znak==207
                        znak:=46
                CASE znak==208
                        znak:=100
                CASE znak==209
                        znak:=68
                CASE znak==210
                        znak:=68
                CASE znak==211
                        znak:=69
                CASE znak==212
                        znak:=100
                CASE znak==213
                        znak:=78
                CASE znak==214
                        znak:=73
                CASE znak==215
                        znak:=73
                CASE znak==216
                        znak:=101
                CASE znak==221
                        znak:=84
                CASE znak==222
                        znak:=85
                CASE znak==224
                        znak:=79
                CASE znak==226
                        znak:=79
                CASE znak==227
                        znak:=78
                CASE znak==228
                        znak:=110
                CASE znak==229
                        znak:=110
                CASE znak==230
                        znak:=83
                CASE znak==231
                        znak:=115
                CASE znak==232
                        znak:=82
                CASE znak==233
                        znak:=85
                CASE znak==234
                        znak:=114
                CASE znak==235
                        znak:=85
                CASE znak==236
                        znak:=121
                CASE znak==237
                        znak:=89
                CASE znak==238
                        znak:=116
                CASE znak==239
                        znak:=46
                CASE znak==240
                        znak:=46
                CASE znak==241
                        znak:=46
                CASE znak==242
                        znak:=46
                CASE znak==243
                        znak:=46
                CASE znak==244
                        znak:=46
                CASE znak==245
                        znak:=173
                CASE znak==247
                        znak:=46
                CASE znak==248
                        znak:=46
                CASE znak==249
                        znak:=46
                CASE znak==251
                        znak:=117
                CASE znak==252
                        znak:=82
                CASE znak==253
                        znak:=114
                * doplnenie spracovania aj wildcard pre hladtext iba
                ** hviezdika *
                CASE znak==42
                        znak:=42
                ** otznik ?
                CASE znak==63
                        znak:=63
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok

***************************************
FUNCTION LAT_IBM_U(ptext)                 // Funkcia pre odstranenie diakritiky z textu v LATIN-2
***************************************
* upraven pre Windows CE,EE CP1250
**************************************************
* Prekdovanie je poda tabuku Windows CE, EE CP1250 do kdov bez diakritiky
* zkladn ASCII ktor je spolon pre vetky kdov strnky od chr 0 do 127

LOCAL outriadok:=space(0),pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet
                znak:=asc(ptext[i])

                * prekduje znaky s diakritikou do kdov bez
                * ostatn nevyuit kdy nech tak
*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127
                DO CASE
*                CASE znak==128
*                        znak:=67
*                CASE znak==129
*                        znak:=117
*                CASE znak==130
*                        znak:=101
*                CASE znak==131
*                        znak:=97
*                CASE znak==132
*                        znak:=97
*                CASE znak==133
*                        znak:=117
*                CASE znak==134
*                        znak:=99
*                CASE znak==135
*                        znak:=99
*                CASE znak==136
*                        znak:=108
*                CASE znak==137
*                        znak:=101
                * 
                CASE znak==138
                        znak:=83
*                CASE znak==139
*                        znak:=111
*                CASE znak==140
*                        znak:=105
                * 
                CASE znak==141
                        znak:=84
                * 
                CASE znak==142
                        znak:=90
*                CASE znak==143
*                        znak:=67
*                CASE znak==144
*                        znak:=69
*                CASE znak==145
*                        znak:=76
*                CASE znak==146
*                        znak:=108
*                CASE znak==147
*                        znak:=111
*                CASE znak==148
*                        znak:=111
*                CASE znak==149
*                        znak:=76
*                CASE znak==150
*                        znak:=108
*                CASE znak==151
*                        znak:=83
*                CASE znak==152
*                        znak:=115
*                CASE znak==153
*                        znak:=79
                * 
                CASE znak==154
                        znak:=115
*                CASE znak==155
*                        znak:=84
*                CASE znak==156
*                        znak:=116
                * 
                CASE znak==157
                        znak:=116
                * 
                CASE znak==158
                        znak:=122
*                CASE znak==159
*                        znak:=99
*                CASE znak==160
*                        znak:=97
*                CASE znak==161
*                        znak:=105
*                CASE znak==162
*                        znak:=111
*                CASE znak==163
*                        znak:=117
*                CASE znak==164
*                        znak:=65
*                CASE znak==165
*                        znak:=97
*                CASE znak==166
*                        znak:=90
*                CASE znak==167
*                        znak:=122
*                CASE znak==168
*                        znak:=69
*                CASE znak==169
*                        znak:=101
*                CASE znak==170
*                        znak:=32
*                CASE znak==171
*                        znak:=122
*                CASE znak==172
*                        znak:=67
*                CASE znak==173
*                        znak:=115
*                CASE znak==174
*                        znak:=115
*                CASE znak==175
*                        znak:=115
*                CASE znak==176
*                        znak:=115
*                CASE znak==177
*                        znak:=115
*                CASE znak==178
*                        znak:=115
*                CASE znak==179
*                        znak:=115
*                CASE znak==180
*                        znak:=115
*                CASE znak==181
*                        znak:=65
*                CASE znak==182
*                        znak:=65
*                CASE znak==183
*                        znak:=69
*                CASE znak==184
*                        znak:=83
*                CASE znak==185
*                        znak:=83
*                CASE znak==186
*                        znak:=83
*                CASE znak==187
*                        znak:=83
                * 
                CASE znak==188
                        znak:=76
*                CASE znak==189
*                        znak:=90
                * 
                CASE znak==190
                        znak:=108
*                CASE znak==191
*                        znak:=108
                * 
                CASE znak==192
                        znak:=82
                * 
                CASE znak==193
                        znak:=65
*                CASE znak==194
*                        znak:=108
*                CASE znak==195
*                        znak:=108
                * A irok
                CASE znak==196
                        znak:=65
                * 
                CASE znak==197
                        znak:=76
*                CASE znak==198
*                        znak:=65
*                CASE znak==199
*                        znak:=97
                * 
                CASE znak==200
                        znak:=67
                * 
                CASE znak==201
                        znak:=69
*                CASE znak==202
*                        znak:=46
                * E s dvoma bodkami
                CASE znak==203
                        znak:=69
                * 
                CASE znak==204
                        znak:=69
                * 
                CASE znak==205
                        znak:=73
*                CASE znak==206
*                        znak:=46
                * 
                CASE znak==207
                        znak:=68
*                CASE znak==208
*                        znak:=100
*                CASE znak==209
*                        znak:=68
                * 
                CASE znak==210
                        znak:=78
                * 
                CASE znak==211
                        znak:=79
                * O s vkaom
                CASE znak==212
                        znak:=79
                * O s dvoma iarkami
                CASE znak==213
                        znak:=79
                * O s dvoma bodkami
                CASE znak==214
                        znak:=79
*                CASE znak==215
*                        znak:=73
                * 
                CASE znak==216
                        znak:=82
                * U s krkom
                CASE znak==217
                        znak:=85
                * 
                CASE znak==218
                        znak:=85
                * U s dvoma iarkami
                CASE znak==219
                        znak=85
                * U s dvoma bodkami
                CASE znak==220
                        znak:=85
                * 
                CASE znak==221
                        znak:=89
*                CASE znak==222
*                        znak:=85
*                CASE znak==223
*                        znak:=85
                * 
                CASE znak==224
                        znak:=114
                * 
                CASE znak==225
                        znak:=97
*                CASE znak==226
*                        znak:=79
*                CASE znak==227
*                        znak:=78
                * 
                CASE znak==228
                        znak:=97
                * 
                CASE znak==229
                        znak:=108
*                CASE znak==230
*                        znak:=83
*                CASE znak==231
*                        znak:=115
                * 
                CASE znak==232
                        znak:=99
                * 
                CASE znak==233
                        znak=101
*                CASE znak==234
*                        znak:=114
*                CASE znak==235
*                        znak:=85
                * 
                CASE znak==236
                        znak:=101
                * 
                CASE znak==237
                        znak:=105
*                CASE znak==238
*                        znak:=116
                * 
                CASE znak==239
                        znak:=100
*                CASE znak==240
*                        znak:=46
*                CASE znak==241
*                        znak:=46
                * 
                CASE znak==242
                        znak:=110
                * 
                CASE znak==243
                        znak:=111
                * 
                CASE znak==244
                        znak=111
                * o s dvoma iarkami
                CASE znak==245
                        znak:=111
                * o s dvoma bodkami
                CASE znak==246
                        znak:=111
*                CASE znak==247
*                        znak:=46
                * 
                CASE znak==248
                        znak:=114
                * u s krkom
                CASE znak==249
                        znak:=117
                * 
                CASE znak==250
                        znak:=117
                * u s dvoma iarkami
                CASE znak==251
                        znak:=117
                * u s dvoma bodkami
                CASE znak==252
                        znak:=117
                * 
                CASE znak==253
                        znak:=121
*                CASE znak==254
*                        znak:=114
*                CASE znak==255
*                        znak:=114
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok




FUNCTION SQLExpressKey(); Return NIL   // <-- put your SQLExpress license key here
// <-- put your SQLExpress license key here



